#ifndef NES_H
#define NES_H

#define SECTION_FAST //.section emu.fast, "awx"
#define SECTION_SLOW //.section emu.slow, "awx"
#define SECTION_HEAD //.section emu.head, "awx"

#define ALIGN .align 4

/*
 * 6502 Υ쥸
 *
 * A Ͼ 24 ӥåȥեȤƤ
 * P 2Ĥʬ롣
 * NZϤۤȤɤ̿᤬ѹΤǡNZθˤʤͤ¸
 * Ĥ¾ξ֤
 *
 * S 24ӥåȥեȤƤ
 * ;äƲΥӥåȤ P λĤ֤(VBDI)
 * ;äƤȤˤϳߤ˴ؤե饰֤
 *
 * PC ROMΥɥ쥹ѴƤ
 * ξ϶å򤷤ۤΤñǤϤʤ
 *  PC 뤿ˤϸߤΥХ󥯤Ƭɥ쥹Ф褤
 */
#define REG_A  r4
#define REG_X  r5
#define REG_Y  r6
#define REG_PC r7
#define REG_S  r8
#define REG_NZ  r9
#define REG_P_REST REG_S

#if 0
/*
 * REG_P ǻȤե饰
 */
#define ARM_N_FLAG 0x80000000
#define ARM_Z_FLAG 0x40000000
#define ARM_C_FLAG 0x20000000
#define ARM_V_FLAG 0x10000000
#endif

/*
 * REG_P_REST ˤϳƼե饰֤
 *
 * 0
 * FEDCBA98 76543210
 * |||||||| |||||||+---C ꡼ޤϥܥʤ
 * |||||||| ||||||+---NMIȯ
 * |||||||| |||||+---I ߵ
 * |||||||| ||||+---D ʥ⡼
 * |||||||| |||+---B
 * |||||||| ||+---IRQȯ
 * |||||||| |+---V Сե
 * |||||||| +---$2005/$2006 ȥե饰
 * ||||||||
 * |||||||+---$2000[2] 32󥯥
 * ||||||+---$2000[3] ץ饤ȥɥ쥹
 * |||||+---$2000[4] Хå饦ɥɥ쥹
 * ||||+---$2000[5] ץ饤ȥ
 * |||+---̤
 * ||+---$2000[7] NMI
 * |+---$2001[3] Хå饦ɤ
 * +---$2001[4] ץ饤Ȥ
 *
 * 1
 * FEDCBA9876543210
 * |||||||||||||||+---$2002[4] VRAM˽񤭹߲ġ
 * ||||||||||||||+---$2002[5] ץ饤Ȥ¿
 * |||||||||||||+---$2002[6] ץ饤ȥҥå(ǤΤ)
 * ||||||||||||+---$2002[7] VBL
 * |||||||||||+---DMCȯ
 * ||||||||||+---VRAMäƤ
 * ||||||||++---̤
 * ++++++++---S åݥ
 *
 */


/*
 * REG_P_REST ǻȤե饰ŪPƱ֤ˤ
 */
#define P_REST_V_FLAG 0x40
#define P_REST_B_FLAG 0x10
#define P_REST_D_FLAG 0x08
#define P_REST_I_FLAG 0x04
#define P_REST_C_FLAG 0x01
#define P_REST_FLAGS  0x5D

/*
 * ߤȯȥåȤ
 */
#define P_REST_INT_PENDING 0x20
#define P_REST_NMI_PENDING 0x02

#define ASSERT_NMI	orr	REG_P_REST, REG_P_REST, #P_REST_NMI_PENDING
#define ASSERT_INT	orr	REG_P_REST, REG_P_REST, #P_REST_INT_PENDING


/*
 * 6502 Υե饰
 */
#define P_N_FLAG 0x80
#define P_V_FLAG 0x40
#define P_R_FLAG 0x20
#define P_B_FLAG 0x10
#define P_D_FLAG 0x08
#define P_I_FLAG 0x04
#define P_Z_FLAG 0x02
#define P_C_FLAG 0x01

#define NMI_VECTOR   6
#define RESET_VECTOR 4
#define IRQ_VECTOR   2

/*
 * 줿ɥ쥹
 */
#define REG_ADDR r10

/*
 * Ĥꥵ
 */
#define REG_CYCLE r11

/*
 * ̿Υץơ֥
 */
#define REG_OP_TABLE r12

#endif
